searchData={"items":[{"type":"module","title":"Pages","doc":"Entry point for interacting with pages.\n\nPages are built around `t:Pages.Driver.t/0` structs. Drivers hold state about\nthe current connection, implement `@behavior Pages.Driver` and must implement\nthe `String.Chars` protocol to transform themselves into HTML.","ref":"Pages.html"},{"type":"module","title":"Available drivers - Pages","doc":"- `t:Pages.Driver.Conn.t/0` - Given a `t:Plug.Conn.t/0`, this driver will be used.\n- `t:Pages.Driver.LiveView.t/0` - Given a `t:Plug.Conn.t/0` with inner data that\n  appears as if a `Phoenix.LiveView` is configured, this driver will be used.","ref":"Pages.html#module-available-drivers"},{"type":"type","title":"Pages.attrs_t/0","doc":"","ref":"Pages.html#t:attrs_t/0"},{"type":"function","title":"Pages.clear_connect_params/1","doc":"Clears out any params set via `Phoenix.LiveViewTest.put_connect_params/2`","ref":"Pages.html#clear_connect_params/1"},{"type":"function","title":"Pages.click/2","doc":"","ref":"Pages.html#click/2"},{"type":"function","title":"Pages.click/3","doc":"","ref":"Pages.html#click/3"},{"type":"function","title":"Pages.click/4","doc":"Simulates clicking on an element at `selector` with title `title`.\nSet the `method` param to `:post` to click on a link that has `data-method=post`.","ref":"Pages.html#click/4"},{"type":"type","title":"Pages.context_t/0","doc":"","ref":"Pages.html#t:context_t/0"},{"type":"function","title":"Pages.get_context/2","doc":"Returns `value` from `page`'s context. The context is a map that can be used to store test-specific information.\nSee also `put_context/3`.","ref":"Pages.html#get_context/2"},{"type":"function","title":"Pages.handle_redirect/1","doc":"Handles cases where the server issues a redirect to the client without a synchronous interaction from the\nuser. This may be used to handle redirects issued from `c:Phoenix.LiveView.handle_info/2` callbacks, for instance.","ref":"Pages.html#handle_redirect/1"},{"type":"type","title":"Pages.http_method/0","doc":"","ref":"Pages.html#t:http_method/0"},{"type":"type","title":"Pages.live_view_upload/0","doc":"","ref":"Pages.html#t:live_view_upload/0"},{"type":"function","title":"Pages.new/2","doc":"Instantiates a new page.","ref":"Pages.html#new/2"},{"type":"function","title":"Pages.open_browser/1","doc":"Attempt to open the current page in a web browser.","ref":"Pages.html#open_browser/1"},{"type":"type","title":"Pages.page_type_t/0","doc":"","ref":"Pages.html#t:page_type_t/0"},{"type":"function","title":"Pages.put_context/2","doc":"","ref":"Pages.html#put_context/2"},{"type":"function","title":"Pages.put_context/3","doc":"Puts `value` in `page`'s context and returns the page (not the context). The context is a map that can be used to\nstore test-specific information. See also `get_context/2`.","ref":"Pages.html#put_context/3"},{"type":"function","title":"Pages.render_change/3","doc":"Render a change to the element at `selector` with the value `value`. See `Phoenix.LiveViewTest.render_change/2` for\na description of the `value` field.","ref":"Pages.html#render_change/3"},{"type":"function","title":"Pages.render_hook/4","doc":"Sends a hook event to the live view.","ref":"Pages.html#render_hook/4"},{"type":"function","title":"Arguments - Pages.render_hook/4","doc":"| name        | decription |\n| ----------- | ---------- |\n| page        | The current page struct. |\n| event       | The event name to send to `handle_event`. |\n| value_attrs | A map of params to send to `handle_event`. |\n| opts        | An optional keyword list of options. |","ref":"Pages.html#render_hook/4-arguments"},{"type":"function","title":"Options - Pages.render_hook/4","doc":"| name   | description |\n| ------ | ----------- |\n| target | The selector of an embedded live componont to receive the event. Example: `#sub-module` |\n\nSee `Phoenix.LiveViewTest.render_hook/3` for more information.","ref":"Pages.html#render_hook/4-options"},{"type":"function","title":"Pages.render_upload/4","doc":"Performs an upload of a file input and renders the result. See `Phoenix.LiveViewTest.file_input/4` for\na description of the `upload` field.","ref":"Pages.html#render_upload/4"},{"type":"function","title":"Pages.rerender/1","doc":"Re-renders the page.","ref":"Pages.html#rerender/1"},{"type":"type","title":"Pages.result/0","doc":"In most cases, when interacting with pages, a new page will be returned (either a\n`%Pages.Driver.LiveView{}` or a `%Pages.Driver.Conn{}`). When actions redirect to\nan external URL, `Pages` functions will return a tuple with `{:error, :external, url}`","ref":"Pages.html#t:result/0"},{"type":"function","title":"Pages.submit_form/2","doc":"Submits a form without specifying any attributes. This function will submit any values\ncurrently set in the form HTML.","ref":"Pages.html#submit_form/2"},{"type":"function","title":"Pages.submit_form/3","doc":"Fills in a form with `attributes` and submits it. Hidden parameters can by send by including\na fifth enumerable.","ref":"Pages.html#submit_form/3"},{"type":"function","title":"Arguments - Pages.submit_form/3","doc":"| name         | decription |\n| ------------ | ---------- |\n| page         | The current page struct. |\n| selector     | A CSS selector matching the form. |\n| schema       | An optional atom representing the schema of the form. Attributes will be nested under this key when submitted. See [Schema](#submit_form/4-schema). |\n| attrs        | A map of attributes to send. |\n| hidden_attrs | An optional map or keyword of hidden values to include. |","ref":"Pages.html#submit_form/3-arguments"},{"type":"function","title":"Schema - Pages.submit_form/3","doc":"This atom determines the key under which attrs will be nested when sent to the server,\nand corresponds to the atom which an `t:Ecto.Changeset.t/0` serializes to, or the value\nof `:as` passed to `Phoenix.HTML.FormData.to_form/4`.\n\nWhen a schema is passed, the form attrs will be received as nested params under the schema\nkey.\n\nIf one wishes to construct the full nested map of attrs, then the schema may be omitted.","ref":"Pages.html#submit_form/3-schema"},{"type":"function","title":"Examples - Pages.submit_form/3","doc":"``` elixir\niex> conn = Phoenix.ConnTest.build_conn()\niex> page = Pages.visit(conn, \"/live/form\")\niex> Pages.submit_form(page, \"#form\", :foo, value: \"rerender\")\n\niex> conn = Phoenix.ConnTest.build_conn()\niex> page = Pages.visit(conn, \"/live/form\")\niex> Pages.submit_form(page, \"#form\", foo: [value: \"rerender\"])\n\n```","ref":"Pages.html#submit_form/3-examples"},{"type":"function","title":"Notes - Pages.submit_form/3","doc":"When used with LiveView, this will trigger `phx-submit` with the specified attributes,\nand handles `phx-trigger-action` if present.","ref":"Pages.html#submit_form/3-notes"},{"type":"function","title":"Pages.submit_form/4","doc":"","ref":"Pages.html#submit_form/4"},{"type":"function","title":"Pages.submit_form/5","doc":"","ref":"Pages.html#submit_form/5"},{"type":"type","title":"Pages.text_filter/0","doc":"","ref":"Pages.html#t:text_filter/0"},{"type":"function","title":"Pages.update_form/3","doc":"","ref":"Pages.html#update_form/3"},{"type":"function","title":"Pages.update_form/4","doc":"","ref":"Pages.html#update_form/4"},{"type":"function","title":"Pages.update_form/5","doc":"Updates fields in a form with `attributes`, without submitting the form.","ref":"Pages.html#update_form/5"},{"type":"function","title":"Arguments - Pages.update_form/5","doc":"| name     | decription |\n| -------- | ---------- |\n| page     | The current page struct. |\n| selector | A CSS selector matching the form. |\n| schema   | An optional atom representing the schema of the form. Attributes will be nested under this key when submitted. See [Schema](#submit_form/4-schema). |\n| attrs    | A map of attributes to send. |\n| opts     | A keyword list of options. |","ref":"Pages.html#update_form/5-arguments"},{"type":"function","title":"Options - Pages.update_form/5","doc":"| name   | type             | description |\n| ------ | ---------------- | ----------- |\n| target | `list(binary())` | A list to be sent in the `_target` of the form params, indicating which field has been changes. |","ref":"Pages.html#update_form/5-options"},{"type":"function","title":"Schema - Pages.update_form/5","doc":"This atom determines the key under which attrs will be nested when sent to the server,\nand corresponds to the atom which an `t:Ecto.Changeset.t/0` serializes to, or the value\nof `:as` passed to `Phoenix.HTML.FormData.to_form/4`.\n\nWhen a schema is passed, the form attrs will be received as nested params under the schema\nkey.\n\nIf one wishes to construct the full nested map of attrs, then the schema may be omitted.","ref":"Pages.html#update_form/5-schema"},{"type":"function","title":"Examples - Pages.update_form/5","doc":"``` elixir\niex> conn = Phoenix.ConnTest.build_conn()\niex> page = Pages.visit(conn, \"/live/form\")\niex> Pages.update_form(page, \"#form\", :my_form, value: \"baz\")\n\niex> conn = Phoenix.ConnTest.build_conn()\niex> page = Pages.visit(conn, \"/live/form\")\niex> Pages.update_form(page, \"#form\", my_form: [value: \"baz\"])\n\n```","ref":"Pages.html#update_form/5-examples"},{"type":"function","title":"Notes - Pages.update_form/5","doc":"When used with LiveView, this will trigger `phx-change` with the specified attributes,\nand handles `phx-trigger-action` if present.","ref":"Pages.html#update_form/5-notes"},{"type":"function","title":"Pages.visit/2","doc":"","ref":"Pages.html#visit/2"},{"type":"function","title":"Pages.visit/3","doc":"Visits `path`.","ref":"Pages.html#visit/3"},{"type":"function","title":"Pages.with_child_component/3","doc":"Finds a phoenix component with an id matching `child_id`, and passes it to the given\nfunction. This is helpful when a site implements stateful LiveView components, and\nmessages should be directed to a process other than the parent LiveView pid.","ref":"Pages.html#with_child_component/3"},{"type":"function","title":"Examples - Pages.with_child_component/3","doc":"```elixir\nPages.with_child_component(page, \"chat-component\", fn child ->\n  Pages.submit_form(child,\n    [test_role: \"new-chat-message\"],\n    :chat_message,\n    contents: \"Hi there!\")\nend)\n```","ref":"Pages.html#with_child_component/3-examples"},{"type":"behaviour","title":"Pages.Driver","doc":"Defines types and behaviours that page drivers must implement.","ref":"Pages.Driver.html"},{"type":"callback","title":"Pages.Driver.click/4","doc":"Click an element within a page. Implementation for `Pages.click/4`.","ref":"Pages.Driver.html#c:click/4"},{"type":"callback","title":"Pages.Driver.handle_redirect/1","doc":"Wait for a server-issued redirect. Implementation for `Pages.handle_redirect/1`.","ref":"Pages.Driver.html#c:handle_redirect/1"},{"type":"callback","title":"Pages.Driver.open_browser/1","doc":"Attempt to open the current page in a web browser.","ref":"Pages.Driver.html#c:open_browser/1"},{"type":"callback","title":"Pages.Driver.render_change/3","doc":"Render a change. Implementation for `Pages.render_change/3`.","ref":"Pages.Driver.html#c:render_change/3"},{"type":"callback","title":"Pages.Driver.render_hook/4","doc":"Render a hook event. Implementation for `Pages.render_hook/3`.","ref":"Pages.Driver.html#c:render_hook/4"},{"type":"callback","title":"Pages.Driver.render_upload/4","doc":"Render a file upload. Implementation for `Pages.render_upload/4`.","ref":"Pages.Driver.html#c:render_upload/4"},{"type":"callback","title":"Pages.Driver.rerender/1","doc":"Re-renders the page. Implementation for `Pages.rerender/1`.","ref":"Pages.Driver.html#c:rerender/1"},{"type":"callback","title":"Pages.Driver.submit_form/2","doc":"Submit a form targeted by the given selector. Implementation for `Pages.submit_form/2`.","ref":"Pages.Driver.html#c:submit_form/2"},{"type":"callback","title":"Pages.Driver.submit_form/4","doc":"Submit a form targeted by the given selector. Implementation for `Pages.submit_form/3`.","ref":"Pages.Driver.html#c:submit_form/4"},{"type":"callback","title":"Pages.Driver.submit_form/5","doc":"Fills in a form with the attributes and submits it. Implementation for `Pages.submit_form/5`.","ref":"Pages.Driver.html#c:submit_form/5"},{"type":"type","title":"Pages.Driver.t/0","doc":"","ref":"Pages.Driver.html#t:t/0"},{"type":"callback","title":"Pages.Driver.update_form/4","doc":"Fills in a form with the attributes without submitting it. Implementation for `Pages.update_form/4`.\n\nWhen interactive with forms backed by multiple changesets, or forms not backed by any changesets,\none may choose to pass custon nested maps or keywords matching the structure of the params to be\nreceived in a controller or live view.","ref":"Pages.Driver.html#c:update_form/4"},{"type":"callback","title":"Pages.Driver.update_form/5","doc":"Fills in a form with the attributes without submitting it. Implementation for `Pages.update_form/5`.\n\nWhen updating a form built using `Phoenix.Component.to_form/2` with the `:as` option, one may use\nthe `name` prefix of the form as the `:schema` atom.","ref":"Pages.Driver.html#c:update_form/5"},{"type":"callback","title":"Pages.Driver.visit/2","doc":"Navigate directly to a page. Implementation for `Pages.visit/2`.","ref":"Pages.Driver.html#c:visit/2"},{"type":"callback","title":"Pages.Driver.with_child_component/3","doc":"Target a child component for actions. Implementation for `Pages.with_child_component/3`.","ref":"Pages.Driver.html#c:with_child_component/3"},{"type":"module","title":"Pages.Driver.Conn","doc":"A page driver for interacting with Phoenix controllers.","ref":"Pages.Driver.Conn.html"},{"type":"function","title":"Pages.Driver.Conn.click/4","doc":"Simulates clicking on an element at `selector` with title `title`.","ref":"Pages.Driver.Conn.html#click/4"},{"type":"function","title":"Pages.Driver.Conn.new/2","doc":"","ref":"Pages.Driver.Conn.html#new/2"},{"type":"function","title":"Pages.Driver.Conn.open_browser/1","doc":"Not yet implemented for this driver.","ref":"Pages.Driver.Conn.html#open_browser/1"},{"type":"type","title":"Pages.Driver.Conn.t/0","doc":"","ref":"Pages.Driver.Conn.html#t:t/0"},{"type":"module","title":"Pages.Driver.LiveView","doc":"A page driver for interacting with Phoenix.LiveView pages.","ref":"Pages.Driver.LiveView.html"},{"type":"function","title":"Pages.Driver.LiveView.click/4","doc":"Called from `Pages.click/4` when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#click/4"},{"type":"function","title":"Pages.Driver.LiveView.handle_redirect/1","doc":"Called from `Pages.handle_redirect/1` when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#handle_redirect/1"},{"type":"function","title":"Pages.Driver.LiveView.live_redirect/2","doc":"Perform a live redirect to the given path.\n\nWhen issuing a live_redirect from one live view to another live view where the\nroutes cross between two `live_session`s, then live view will not just remount\nthe socket, but will issue a redirect. In this case, if the test pages have been\ninitialized via `Phoenix.ConnTest.build_conn/0`, the test adapter will have the\nURI host set to be `www.example.com`... the live_redirect will be seen as an\nexternal redirect.\n\nWhen using `live_redirect/2` between two live sessions, ensure that the initial\ntest setup (for example in ConnCase) instead calls\n`Phoenix.ConnTest.build_conn(:get, \"http://localhost:4002/\")`, so that redirects\nare seen as internal redirects.\n\nThis is not implemented in `Pages` due to its specificity to LiveView and LiveViewTest.","ref":"Pages.Driver.LiveView.html#live_redirect/2"},{"type":"function","title":"Pages.Driver.LiveView.new/2","doc":"","ref":"Pages.Driver.LiveView.html#new/2"},{"type":"function","title":"Pages.Driver.LiveView.new/4","doc":"","ref":"Pages.Driver.LiveView.html#new/4"},{"type":"function","title":"Pages.Driver.LiveView.open_browser/1","doc":"Attempt to open the current page in a web browser.","ref":"Pages.Driver.LiveView.html#open_browser/1"},{"type":"function","title":"Pages.Driver.LiveView.render_change/3","doc":"Called from `Pages.render_change/3` when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#render_change/3"},{"type":"function","title":"Pages.Driver.LiveView.render_hook/4","doc":"Called from `Pages.render_hook/3` when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#render_hook/4"},{"type":"function","title":"Pages.Driver.LiveView.render_upload/4","doc":"Called from `Pages.render_upload/4` when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#render_upload/4"},{"type":"function","title":"Pages.Driver.LiveView.rerender/1","doc":"Called from `Pages.rerender/1` when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#rerender/1"},{"type":"function","title":"Pages.Driver.LiveView.submit_form/2","doc":"Called from `Pages.submit_form/2` when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#submit_form/2"},{"type":"function","title":"Pages.Driver.LiveView.submit_form/5","doc":"Called from `Pages.submit_form/4` and `Pages.submit_form/5` when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#submit_form/5"},{"type":"type","title":"Pages.Driver.LiveView.t/0","doc":"","ref":"Pages.Driver.LiveView.html#t:t/0"},{"type":"function","title":"Pages.Driver.LiveView.update_form/5","doc":"Called from `Pages.update_form/5` when the given page is a LiveView.","ref":"Pages.Driver.LiveView.html#update_form/5"},{"type":"function","title":"Pages.Driver.LiveView.visit/2","doc":"Initialize a `live` with the given path.\n\nThis is called from `Pages.visit/2` when the conn indicates that the pages is a LiveView,\nand should only be called directly if the parent function does not work for some reason.","ref":"Pages.Driver.LiveView.html#visit/2"},{"type":"function","title":"Pages.Driver.LiveView.with_child_component/3","doc":"Find a child component, and pass it as a new Page into the given function.\n\nRerenders the top-level page upon completion. See `Pages.with_child_component/3`.","ref":"Pages.Driver.LiveView.html#with_child_component/3"},{"type":"exception","title":"Pages.Error","doc":"Errors that are specifically raised from page drivers.","ref":"Pages.Error.html"},{"type":"extras","title":"Pages","doc":"# Pages\n\n[![CI](https://github.com/synchronal/pages/actions/workflows/tests.yml/badge.svg \"CI\")](https://github.com/synchronal/pages/actions)\n[![Hex pm](http://img.shields.io/hexpm/v/pages.svg?style=flat \"Hex version\")](https://hex.pm/packages/pages)\n[![API docs](https://img.shields.io/hexpm/v/pages.svg?label=hexdocs \"API docs\")](https://hexdocs.pm/pages/Pages.html)\n[![License](http://img.shields.io/github/license/synchronal/pages.svg?style=flat \"License\")](https://github.com/synchronal/pages/blob/main/LICENSE.md)\n\n_Pages_ is a tool for testing Phoenix web applications purely in fast asynchronous Elixir tests, without the need for a\nweb browser. It can seamlessly move between LiveView-based pages (via\n[Phoenix.LiveViewTest](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveViewTest.html)) and controller-based pages\n(via [Phoenix.ConnTest](https://hexdocs.pm/phoenix/Phoenix.ConnTest.html)), so web tests are as fast as all other unit\ntests.\n\nPages has been used for testing multiple applications over the past 2+ years without much need for API changes.\n\nThis library is tested against the latest 3 major versions of Elixir.","ref":"readme.html"},{"type":"extras","title":"Quick Overview - Pages","doc":"","ref":"readme.html#quick-overview"},{"type":"extras","title":"Interacting With A Web App - Pages","doc":"The `Pages.new/1` function creates a new `Pages.Driver` struct from the conn, and most of the rest of the `Pages`\nfunctions expect that driver to be passed in as the first argument and will return that driver:\n\n```elixir\nprofile_page =\n  conn\n  |> Pages.new()\n  |> Pages.visit(Web.Paths.auth())\n  |> Pages.submit_form(\"[test-role=auth]\", :user, name: \"alice\", password: \"password1234\")\n  |> Pages.click(\"[test-role=my-profile-button]\")\n\n# `profile_page` now references a `Pages.Driver.LiveView` struct.\n```\n\n(Curious about `Web.Paths.auth()` above? Read this article: [Web.Paths](https://eahanson.com/articles/web-paths).)\n\nSee Pages' [API reference](https://hexdocs.pm/pages/api-reference.html) for more info, specifically the docs for the\n[Pages](https://hexdocs.pm/pages/Pages.html) module.","ref":"readme.html#interacting-with-a-web-app"},{"type":"extras","title":"Finding Elements On A Page - Pages","doc":"Instead of having a bespoke API for parsing HTML, Pages allows you to use your favorite HTML parsing\nlibrary.\n\nWe naturally recommend the one we built: [`HtmlQuery`](https://hexdocs.pm/html_query/readme.html). It and its XML\ncounterpart [`XmlQuery`](https://hexdocs.pm/xml_query/readme.html) have the same concise API. The main functions are:\n`all/2`, `find/2`, `find!/2`, `attr/2`, and `text/1`.\n\nYou can use a different library or your own code. The drivers (`Pages.Driver.Conn` and `Pages.Driver.LiveView`)\nimplement the `String.Chars` protocol, so you can call `to_string/0` on any page to get its rendered result.\n\nHere's an example of using `HtmlQuery` to get all the email addresses from the `profile_page`:\n\n```elixir\nalias HtmlQuery, as: Hq\n\n# ...\n\nemail_addresses =\n  dashboard_page\n  |> Hq.all(\"ul[test-role=email-addresses] li\")\n  |> Enum.map(&Hq.text/1)\n\nassert email_addresses == [\"alice@example.com\", \"alice@example.net\"]\n```","ref":"readme.html#finding-elements-on-a-page"},{"type":"extras","title":"Optional: Taming Complexity With The Page Object Pattern - Pages","doc":"In a large web application, test complexity becomes an issue. One way to solve web test complexity is by using\nthe [Page Object](https://martinfowler.com/bliki/PageObject.html) pattern for encapsulating each page's content,\nactions, and assertions in its own module.\n\nUsing the Pages library does not require implementing the page object pattern, and implementing the page object\npattern doesn't necessitate using the Pages library. However, we find it to be an extremely effective way to keep\ntests simple so we'll provide an example of implementing the pattern with Pages.\n\nThe typical usage is to create a module for each page of your web app, with functions for each action that a user can\ntake on that page, and then to call those functions in a test. Note that in this example, `Web` and `Test` are\ntop-level modules in the app that's being tested.\n\n```elixir\ndefmodule Web.HomeLiveTest do\n  use Test.ConnCase, async: true\n\n  test \"has login button\", %{conn: conn} do\n    conn\n    |> Pages.new()\n    |> Test.Pages.HomePage.assert_here()\n    |> Test.Pages.HomePage.click_login_link()\n    |> Test.Pages.LoginPage.assert_here()\n  end\nend\n```\n\nHere is the definition of the `HomePage` module that's used in the test above. This test uses `assert_eq/3` from the\n[Moar](https://hexdocs.pm/moar/Moar.Assertions.html#assert_eq/3) library, and `find/2` & `attr/2` from the\n[HtmlQuery](https://hexdocs.pm/html_query/HtmlQuery.html) library.\n\n```elixir\ndefmodule Test.Pages.HomePage do\n  import Moar.Assertions\n  alias HtmlQuery, as: Hq\n\n  @spec assert_here(Pages.Driver.t()) :: Pages.Driver.t()\n  def assert_here(%Pages.Driver.LiveView{} = page) do\n    page\n    |> Hq.find(\"[data-page]\")\n    |> Hq.attr(\"data-page\")\n    |> assert_eq(\"home\", returning: page)\n  end\n\n  @spec click_login_link(Pages.Driver.t()) :: Pages.Driver.t()\n  def click_login_link(page),\n    do: page |> Pages.click(\"Log In\", test_role: \"login-link\")\n\n  @spec visit(Pages.Driver.t()) :: Pages.Driver.t()\n  def visit(page),\n    do: page |> Pages.visit(\"/\")\nend\n```\n\nA page module that you define can work with either a controller-based page or a LiveView-based page, and a test can\ntest workflows that use both controllers and LiveViews.","ref":"readme.html#optional-taming-complexity-with-the-page-object-pattern"},{"type":"extras","title":"The Context - Pages","doc":"If you have information you'd like to keep while stepping through multiple pages, you can assign it to the\ncontext from functions like `Pages.new` and `Pages.visit`:\n\n```elixir\npage =\n  conn\n  |> Pages.visit(\"/live/form\", some_key: \"some_value\")\n  |> Pages.update_form(\"#form\", foo: [action: \"redirect\"])\n  |> assert_here(\"pages/show\")\n\nassert page.context == %{some_key: \"some_value\"}\n```","ref":"readme.html#the-context"},{"type":"extras","title":"Installation - Pages","doc":"```elixir\ndef deps do\n  [\n    {:pages, \"~> 3.1\", only: :test}\n  ]\nend\n```\n\nConfigure your endpoint in `config/test.exs`:\n\n```elixir\nconfig :pages, :phoenix_endpoint, Web.Endpoint\n```","ref":"readme.html#installation"},{"type":"extras","title":"Alternatives - Pages","doc":"The relatively recent [`phoenix_test`](https://github.com/germsvel/phoenix_test) library is similar in that it handles\ncontroller- and LiveView-based tests. Its API style is quite different that Pages' API.\n\nFor tests that run in a real browser, the venerable [`Wallaby`](https://github.com/elixir-wallaby/wallaby) is\nthe only production-ready choice at the moment.\n\n[`playwright-elixir`](https://github.com/mechanical-orchard/playwright-elixir) is an Elixir driver for Playwright.\nIts readme says that \"the features are not yet at parity with other Playwright implementations\" but it might be\nworth checking out.","ref":"readme.html#alternatives"},{"type":"extras","title":"Under the hood - Pages","doc":"This library uses functions from [Phoenix.ConnTest](https://hexdocs.pm/phoenix/Phoenix.ConnTest.html) and\nfrom [Phoenix.LiveViewTest](https://hexdocs.pm/phoenix_live_view/Phoenix.LiveViewTest.html) to simulate a user clicking\naround and therefore can't test any Javascript functionality. To fix this, a driver for browser-based testing via\n[Wallaby](https://github.com/elixir-wallaby/wallaby) or\n[Playwright Elixir](https://github.com/geometerio/playwright-elixir) would be needed, but one does not yet exist. The\nupside is that Pages-based tests are extremely fast.","ref":"readme.html#under-the-hood"},{"type":"extras","title":"LICENSE","doc":"Copyright 2022 synchronal.dev\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated\ndocumentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the\nrights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit\npersons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the\nSoftware.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE\nWARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR\nCOPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR\nOTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}